Package ghidra.graph.viewer.layout

# Class LayoutLocationMap<V,E>

java.lang.Object
ghidra.graph.viewer.layout.LayoutLocationMap<V,E>

Type Parameters:
  `V` - the vertex type
  `E` - the edge type

public class LayoutLocationMap<V,E> extends Object
A class that holds row and column data for each vertex and edge.

This class will take in a `GridLocationMap`, which is comprised of grid index values, not layout space points. Then, the grid values will be used to calculate offsets and size for each row and column. Each row has a y location and a height; each column has an x location and a width. The height and width are uniform in size across all rows and columns, based upon the tallest and widest vertex in the graph.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LayoutLocationMap(GridLocationMap<V,E> gridLocations, com.google.common.base.Function<V,Shape> transformer, boolean isCondensed, TaskMonitor monitor)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<Point>`
  `articulations(E e)`
  `Column`
  `col(int gridX)`
  `Column`
  `col(V v)`
  `Collection<Column>`
  `columns()`
  Returns the columns in this location map, sorted from lowest index to highest
  `LayoutLocationMap<V,E>`
  `copy()`
  `void`
  `dispose()`
  `List<Integer>`
  `getColOffsets()`
  `Column`
  `getColumnContaining(int x)`
  `int`
  `getColumnCount()`
  `int`
  `getRowCount()`
  `List<Integer>`
  `getRowOffsets()`
  `int`
  `gridX(Column col)`
  `int`
  `gridY(Row<V> row)`
  `boolean`
  `isCondensed()`
  `Column`
  `lastColumn()`
  `Row<V>`
  `lastRow()`
  `Column`
  `nextColumn(Column column)`
  `Row<V>`
  `row(int gridY)`
  `Row<V>`
  `row(V v)`
  `Collection<Row<V>>`
  `rows()`
  Returns the rows in this location map, sorted from lowest index to highest
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### LayoutLocationMap

    public LayoutLocationMap(GridLocationMap<V,E> gridLocations, com.google.common.base.Function<V,Shape> transformer, boolean isCondensed, TaskMonitor monitor) throws CancelledException
    Throws:
      `CancelledException`

- ## Method Details

  - ### copy

    public LayoutLocationMap<V,E> copy()

  - ### dispose

    public void dispose()

  - ### getRowCount

    public int getRowCount()

  - ### getColumnCount

    public int getColumnCount()

  - ### col

    public Column col(V v)

  - ### col

    public Column col(int gridX)

  - ### getColumnContaining

    public Column getColumnContaining(int x)

  - ### columns

    public Collection<Column> columns()
    Returns the columns in this location map, sorted from lowest index to highest
    Returns:
      the columns in this location map, sorted from lowest index to highest

  - ### rows

    public Collection<Row<V>> rows()
    Returns the rows in this location map, sorted from lowest index to highest
    Returns:
      the rows in this location map, sorted from lowest index to highest

  - ### lastColumn

    public Column lastColumn()

  - ### nextColumn

    public Column nextColumn(Column column)

  - ### articulations

    public List<Point> articulations(E e)

  - ### row

    public Row<V> row(V v)

  - ### lastRow

    public Row<V> lastRow()

  - ### row

    public Row<V> row(int gridY)

  - ### gridX

    public int gridX(Column col)

  - ### gridY

    public int gridY(Row<V> row)

  - ### getRowOffsets

    public List<Integer> getRowOffsets()

  - ### getColOffsets

    public List<Integer> getColOffsets()

  - ### isCondensed

    public boolean isCondensed()

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`